"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.classNames = classNames;
exports.setDefaultProps = setDefaultProps;

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function setDefaultProps(component) {
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var defaultProps = {};
  var propTypes = {};

  for (var key in props) {
    defaultProps[key] = props[key].default;
    propTypes[key] = props[key].type;
  }

  component['defaultProps'] = defaultProps;
  component['propTypes'] = propTypes;
}

function classNames() {
  var classes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var arr = [];
  classes.forEach(function (item) {
    if (_typeof(item) === 'object') {
      for (var key in item) {
        if (item[key] === true) {
          arr.push(key);
        }
      }
    } else {
      arr.push(item);
    }
  });
  return arr.filter(Boolean).join(' ');
}