"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _assist = require("../_util/assist");

var _withPreventScroll = _interopRequireDefault(require("../_hoc/withPreventScroll"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var prefixCls = 'r-flexfixed';
var FlexFixed = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var header = props.header,
      footer = props.footer,
      extra = props.extra,
      children = props.children,
      className = props.className,
      onScroll = props.onScroll,
      onScrollDebounce = props.onScrollDebounce,
      withPreventScroll = props.withPreventScroll,
      hideFooterOnKeyboardShow = props.hideFooterOnKeyboardShow;
  var doc = document.documentElement || document.body;

  var _useState = (0, _react.useState)(true),
      _useState2 = _slicedToArray(_useState, 2),
      showFooter = _useState2[0],
      setShowFooter = _useState2[1];

  var _useState3 = (0, _react.useState)(doc.clientHeight),
      _useState4 = _slicedToArray(_useState3, 1),
      docHeight = _useState4[0];

  var wrapCls = (0, _assist.classNames)([prefixCls, className]);
  var innerCls = "".concat(prefixCls, "-inner");
  var flexFixedRef = (0, _react.useRef)();

  var onMainTouchStart = function onMainTouchStart(e) {
    var main = e.currentTarget;
    main.maxScrollTop = main.scrollHeight - main.offsetHeight;
  };

  var onMainScroll = function onMainScroll(e) {
    var main = e.currentTarget;
    var scrollTop = main.scrollTop;
    var direction = '';

    if (scrollTop > main.prevScrollTop) {
      direction = 'up';
    } else if (scrollTop < main.prevScrollTop) {
      direction = 'down';
    }

    if (e.target.timer) clearTimeout(e.target.timer);
    e.target.timer = setTimeout(function () {
      onScrollDebounce && onScrollDebounce({
        scrollTop: main.scrollTop,
        maxScrollTop: main.maxScrollTop,
        direction: direction
      });
    }, 150);
    onScroll && onScroll({
      scrollTop: main.scrollTop,
      maxScrollTop: main.maxScrollTop,
      direction: direction
    });
    main.prevScrollTop = scrollTop;
  }; // 阻止页面滚动


  (0, _react.useEffect)(function () {
    withPreventScroll && withPreventScroll.init({
      el: flexFixedRef.current
    });
  }, [withPreventScroll]); // 安卓键盘弹起时隐藏footer

  (0, _react.useEffect)(function () {
    if (hideFooterOnKeyboardShow) {
      var hideFooterOnScroll = function hideFooterOnScroll() {
        setShowFooter(doc.scrollTop === 0);
      };

      var hideFooterOnResize = function hideFooterOnResize() {
        setShowFooter(doc.clientHeight / docHeight > 0.8);
      };

      document.addEventListener('scroll', hideFooterOnScroll, false);
      window.addEventListener('resize', hideFooterOnResize, false);
      return function () {
        document.removeEventListener('scroll', hideFooterOnScroll, false);
        window.removeEventListener('resize', hideFooterOnResize, false);
      };
    }
  }, []);
  console.log('flexfixed mounted or updated');
  return /*#__PURE__*/_react.default.createElement("div", {
    className: wrapCls,
    ref: flexFixedRef
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: innerCls
  }, header && /*#__PURE__*/_react.default.createElement("header", null, header), /*#__PURE__*/_react.default.createElement("main", {
    className: "scroll-area",
    onScroll: onMainScroll,
    onTouchStart: onMainTouchStart
  }, children), footer && /*#__PURE__*/_react.default.createElement("footer", {
    style: {
      display: showFooter ? '' : 'none'
    }
  }, footer)), extra);
});
(0, _assist.setDefaultProps)(FlexFixed, {
  className: {
    type: _propTypes.default.string
  },
  header: {
    type: _propTypes.default.node
  },
  footer: {
    type: _propTypes.default.node
  },
  extra: {
    type: _propTypes.default.node
  },
  onScroll: {
    type: _propTypes.default.func
  },
  onScrollDebounce: {
    type: _propTypes.default.func
  },
  hideFooterOnKeyboardShow: {
    type: _propTypes.default.bool,
    default: true
  }
});

var _default = (0, _withPreventScroll.default)( /*#__PURE__*/(0, _react.memo)(FlexFixed));

exports.default = _default;