"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setGlobalConfig = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _modal = _interopRequireDefault(require("../modal"));

var _assist = require("../_util/assist");

var _loadingCircle = _interopRequireDefault(require("../icons/loading-circle"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var prefixCls = 'r-loading';
var globalConfig = {
  icon: /*#__PURE__*/_react.default.createElement(_loadingCircle.default, null)
};
var LoadingBox = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var defaultIcon = props.icon,
      defaultText = props.text,
      textStyle = props.textStyle;

  var _useState = (0, _react.useState)(defaultIcon),
      _useState2 = _slicedToArray(_useState, 2),
      icon = _useState2[0],
      _setIcon = _useState2[1];

  var _useState3 = (0, _react.useState)(defaultText),
      _useState4 = _slicedToArray(_useState3, 2),
      text = _useState4[0],
      _setText = _useState4[1];

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      setIcon: function setIcon(icon) {
        return _setIcon(icon);
      },
      setText: function setText(text) {
        return _setText(text);
      }
    };
  });
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, icon, text && /*#__PURE__*/_react.default.createElement("div", {
    className: "loading-text",
    style: textStyle
  }, text));
});

var createLoading = function createLoading() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _options = options,
      icon = _options.icon,
      text = _options.text,
      textStyle = _options.textStyle;
  var loadingBox;
  options = Object.assign({
    content: /*#__PURE__*/_react.default.createElement(LoadingBox, {
      icon: icon || globalConfig.icon,
      text: text || globalConfig.text,
      textStyle: textStyle,
      ref: function ref(el) {
        return loadingBox = el;
      }
    }),
    showCancel: false,
    showConfirm: false
  }, options);
  options.className = (0, _assist.classNames)([prefixCls, options.className]);

  var loading = _modal.default.create(options);

  loading.update = function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        icon = _ref.icon,
        text = _ref.text;

    if (icon) loadingBox.setIcon(icon);
    if (text) loadingBox.setText(text);
  };

  return loading;
};

var setGlobalConfig = function setGlobalConfig() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  globalConfig = Object.assign(globalConfig, options);
};

exports.setGlobalConfig = setGlobalConfig;
var _default = createLoading;
exports.default = _default;