"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _assist = require("../_util/assist");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var prefixCls = 'r-switch';

var Switch = function Switch(_ref) {
  var defaultChecked = _ref.defaultChecked,
      disabled = _ref.disabled,
      checkedChildren = _ref.checkedChildren,
      unCheckedChildren = _ref.unCheckedChildren,
      onChange = _ref.onChange;

  var _useState = (0, _react.useState)(defaultChecked),
      _useState2 = _slicedToArray(_useState, 2),
      onOff = _useState2[0],
      setOnOff = _useState2[1];

  var _useState3 = (0, _react.useState)(),
      _useState4 = _slicedToArray(_useState3, 2),
      maxLeft = _useState4[0],
      setMaxLeft = _useState4[1];

  var switchRef = (0, _react.useRef)();
  var circleRef = (0, _react.useRef)();
  console.log('Switch mounted or updated');
  (0, _react.useEffect)(function () {
    setOnOff(defaultChecked);
  }, [defaultChecked]);
  (0, _react.useEffect)(function () {
    setMaxLeft(switchRef.current.offsetWidth - circleRef.current.offsetWidth - 3);
  }, []);
  var wrapCls = (0, _assist.classNames)([prefixCls, _defineProperty({}, "".concat(prefixCls, "-checked"), onOff)]);
  var innerCls = "".concat(prefixCls, "-inner");
  var circleStyle = {
    left: onOff ? maxLeft + 'px' : ''
  };

  var onSwitchClick = function onSwitchClick(e) {
    if (disabled) return;
    var tempOnOff = !onOff;
    setOnOff(tempOnOff);
    onChange && onChange(tempOnOff, e);
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: wrapCls,
    ref: switchRef,
    onClick: onSwitchClick
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: innerCls
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "open"
  }, checkedChildren), /*#__PURE__*/_react.default.createElement("div", {
    className: "close"
  }, unCheckedChildren)), /*#__PURE__*/_react.default.createElement("div", {
    className: "circle",
    ref: circleRef,
    style: circleStyle
  }));
};

(0, _assist.setDefaultProps)(Switch, {
  defaultChecked: {
    type: _propTypes.default.bool,
    default: false
  },
  disabled: {
    type: _propTypes.default.bool
  },
  checkedChildren: {
    type: _propTypes.default.node
  },
  unCheckedChildren: {
    type: _propTypes.default.node
  },
  onChange: {
    type: _propTypes.default.func
  }
});

var _default = /*#__PURE__*/(0, _react.memo)(Switch);

exports.default = _default;